const Self = @This();

const getTime = @import("raylib.zig").getTime;

started: bool,
initial: f64,
progress: f64,
target: f64,

pub fn init(target: f64) Self {
    return Self{
        .started = false,
        .initial = 0,
        .progress = 0,
        .target = target,
    };
}

pub fn start(self: *Self) void {
    self.started = true;
    self.progress = 0;
    self.initial = getTime();
}

pub fn finished(self: *Self) bool {
    if (self.started) {
        self.progress = getTime() - self.initial;
        if (self.progress >= self.target) {
            return true;
        } else return false;
    } else {
        return false;
    }
}

pub fn reset(self: *Self) void {
    self.progress = 0;
    self.initial = getTime();
}

pub fn stop(self: *Self) void {
    self.started = false;
}
